/*
 Copyright (c) 2009, hkrn All rights reserved.
 
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:
 
 Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer. Redistributions in binary
 form must reproduce the above copyright notice, this list of conditions and
 the following disclaimer in the documentation and/or other materials
 provided with the distribution. Neither the name of the hkrn nor
 the names of its contributors may be used to endorse or promote products
 derived from this software without specific prior written permission. 
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 DAMAGE.
 */

//
//  MMLEnvelope.h
//  OCMML
//
//  Created by hkrn on 09/02/05.
//  Copyright 2009 hkrn. All rights reserved.
//
//  $Id: MMLEnvelope.h 65 2009-04-25 12:07:49Z hikarin $
//

#define kEngineMaxPipe 3

@interface MMLEnvelope : NSObject
{
    int m_attackTime;
    double m_attackRcpr;
    int m_decayTime;
    double m_decayRcpr;
    double m_sustainLevel;
    double m_releaseTime;
@private
    double m_currentValue;
    double m_releaseStep;
    BOOL m_releasing;
    BOOL m_playing;
    int m_timeInSamples;
    double m_startAmplitude;
}

- (id)initWithAttack:(double)attack
               decay:(double)decay
             sustain:(double)sustain
             release:(double)release;
- (void)setAttack:(double)attack
            decay:(double)decay
          sustain:(double)sustain
          release:(double)release;
- (void)triggerWithZeroStart:(BOOL)zeroStart;
- (void)releaseEnvelope;
- (void)getAmplitudeSamplesLinear:(double *)samples
                            start:(int)start
                              end:(int)end
                         velocity:(double)velocity;
- (void)getAmplitudeSamplesNonLinear:(double *)samples
                               start:(int)start
                                 end:(int)end
                            velocity:(double)velocity;

@property(readonly) double nextAmplitudeLinear;
@property(readonly) BOOL playing;

@end
